//+------------------------------------------------------------------+
//|                                          @two bars indicator.mq4 |
//|                        Copyright 2012, MetaQuotes Software Corp. |
//|                                        http://www.metaquotes.net |
//+------------------------------------------------------------------+
#property copyright "Copyright 2012, MetaQuotes Software Corp."
#property link      "http://www.metaquotes.net"

#property indicator_chart_window
#property indicator_buffers 2
#property indicator_color1 Blue 
#property indicator_color2 Red

extern int    PERIOD             = PERIOD_H1;
extern int    bodybar            = 5;
extern int    SL                 = 50;
//---
double UpBuffer[],
       DownBuffer[];
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
//---- indicators
   SetIndexBuffer(0,UpBuffer);
   SetIndexBuffer(1,DownBuffer); 
//---
   SetIndexStyle(0,DRAW_ARROW,0,1);
   SetIndexArrow(0,159);
   SetIndexStyle(1,DRAW_ARROW,0,1);
   SetIndexArrow(1,159); 
//---
   SetIndexEmptyValue(0,0.0);
   SetIndexEmptyValue(1,0.0);
//---
   SetIndexLabel(0,"Lab BULL");
   SetIndexLabel(1,"Lab BEAR");
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit()
  {
//----
   
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start()
  {
   int  counted_bars=IndicatorCounted();
   if(counted_bars<0) return(-1);

   int limit=Bars-counted_bars-1;
   if (limit>1) limit=Bars-counted_bars-3;
   for(int i=limit; i>=0; i--) {
      double Opn1 = iOpen( Symbol(),PERIOD,i); 
      double Cls1 = iClose(Symbol(),PERIOD,i);
      double Hg1  = iHigh( Symbol(),PERIOD,i);
      double Lw1  = iLow(  Symbol(),PERIOD,i);
      double Opn2 = iOpen( Symbol(),PERIOD,i+1);
      double Cls2 = iClose(Symbol(),PERIOD,i+1); 
      double Hg2  = iHigh( Symbol(),PERIOD,i+1);
      double Lw2  = iLow(  Symbol(),PERIOD,i+1);
      double Opn3 = iOpen( Symbol(),PERIOD,i+2);
      double Cls3 = iClose(Symbol(),PERIOD,i+2);
      
      double highest = MathMax(Hg1,Hg2);
      double lovest  = MathMin(Lw1,Lw2); 
      double stoplevel  = MarketInfo(Symbol(),MODE_STOPLEVEL);
//      Print("stoplevel = ",stoplevel);

      if(SL<stoplevel)  SL= stoplevel;
//      Print("1. SL = ", SL);
      if(SL>=stoplevel) SL= SL; 
//      Print("2. SL = ", SL);
      
//      if(Period()==PERIOD) {
         //---- Sell conditions
         if(Opn3<=Cls3) {
            if ( Opn1>Cls1) {
               if (Opn2>Cls2) {
                  if (Cls1<Cls2) {
//                     Print("highest -Cls1 = ",DoubleToStr(highest -Cls1,Digits));
                     
                     if (highest-Cls1<=500.0*Point)  {
                        DownBuffer[i]= highest; // && highest-Cls1<=SL
                     }
                  }
               }
            }
         }
         //---- Buy conditions
         if(Opn3>=Cls3) {
            if (Opn1<Cls1) {
               if (Opn2<Cls2){
                  if (Cls1>Cls2){
//                     Print("Cls1-lovest = ",DoubleToStr(Cls1-lovest,Digits));
                     if (Cls1-lovest<=500.0*Point)  {
                        UpBuffer[i]= lovest; //  && Cls1-lovest<=SL
                     }
                  }
               }
            }
         }
//      }
   }
   return(0);
}